# -*- coding: utf-8 -*-
## PloneMaintenance
## Run cheduled scripts for routine work in a Plone site, like packing the ZODB
## Copyright (C)2006 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
Installer utility
"""
__version__ = "$Revision: 18683 $"
# $Source$
# $Id: Install.py 18683 2006-01-29 19:25:19Z roeder $
__docformat__ = 'restructuredtext'

from Products.ExternalMethod.ExternalMethod import manage_addExternalMethod

from Products.CMFCore.utils import getToolByName

from Products.PloneMaintenance import install_globals, MaintenanceTask
from Products.PloneMaintenance.global_symbols import *
from Products.PloneMaintenance.Installation import Installation
from Products.PloneMaintenance.PloneMaintenanceTool import addPloneMaintenanceTool


fti_list = (
    MaintenanceTask.factory_type_information,
    )

types_list = (
    "MaintenanceTask",
    )

skin_name = "PloneMaintenance"

product_name = "PloneMaintenance"

def setupTools(self):
    tool_meta_type = 'PloneMaintenance Tool'
    id = "portal_maintenance"

    if not self.objectIds(spec=tool_meta_type):
        addPloneMaintenanceTool(self)
    else:
        pass

def install(self, reinstall=0):
    installation=Installation(self)
    out = installation.out

    installation.setupTypesandSkins(fti_list, skin_name, install_globals, [])

    if not reinstall:
        setupTools(self)

        mainttool = getToolByName(self, 'portal_maintenance')
        scriptsholder = mainttool.scripts

        # Plone Catalog update script
        manage_addExternalMethod(scriptsholder,'updateCatalog',
            'Update the portal catalog',
            PROJECTNAME+'.MaintenanceToolbox',
            'updateCatalog')

        # Plone Catalogs rebuilds script
        manage_addExternalMethod(scriptsholder,'rebuildCatalogs',
            'PloneArticle-aware Rebuild of all Catalogs',
            PROJECTNAME+'.MaintenanceToolbox',
            'rebuildCatalogs')

        # Pack DB script
        manage_addExternalMethod(scriptsholder,'packDB',
            'Pack the main DB or any specified one',
            PROJECTNAME+'.MaintenanceToolbox',
            'packDB')

        # Archive expired content script
        manage_addExternalMethod(scriptsholder,'archiveExpiredContent',
            'Archive expired content script',
            PROJECTNAME+'.MaintenanceToolbox',
            'archiveExpiredContent')

    return installation.report()
